slackbuilds_ponce/system/postgresql/postgresql.SlackBuild

163 lines
4.5 KiB
Text
Raw Normal View History

2010-05-11 15:18:43 +02:00
#!/bin/sh
## Slackware build script for PostgreSQL
## $Revision: 09a9051874b3 $
## $Date: 2013/04/04 14:52:11 $
##
## Copyright 2007-2013 Adis Nezirovic <adis _at_ linux.org.ba>
2010-05-11 15:18:43 +02:00
## Licensed under GNU GPL v2
# Modified by the SlackBuilds.org Project
2010-05-11 15:18:43 +02:00
PRGNAM=postgresql
VERSION=${VERSION:-9.2.4}
BUILD=${BUILD:-1}
TAG=${TAG:-_SBo}
PG_UID=${PG_UID:-209}
PG_GID=${PG_GID:-209}
if [ -z "$ARCH" ]; then
case "$( uname -m )" in
i?86) ARCH=i486 ;;
arm*) ARCH=arm ;;
*) ARCH=$( uname -m ) ;;
esac
fi
CWD=$(pwd)
2010-05-11 15:18:43 +02:00
TMP=${TMP:-/tmp/SBo}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}
# Bail out if user or group isn't valid on your system
# For slackbuilds.org, assigned postgres uid/gid are 209/209
# See http://slackbuilds.org/uid_gid.txt
2010-05-11 15:18:43 +02:00
# Other popular choice is 26/26
if ! grep ^postgres: /etc/group 2>&1 > /dev/null; then
echo " You must have a postgres group to run this script."
echo " # groupadd -g $PG_GID postgres"
2010-05-11 15:18:43 +02:00
exit 1
elif ! grep ^postgres: /etc/passwd 2>&1 > /dev/null; then
echo " You must have a postgres user to run this script."
echo " # useradd -u $PG_UID -g $PG_GID -d /var/lib/pgsql postgres"
2010-05-11 15:18:43 +02:00
exit 1
fi
# Enable NLS builds using 'ENABLE_NLS=1 ./postgresql.SlackBuild'
if [ ! -z $ENABLE_NLS ];then
NLS=enable
else
NLS=disable
fi
2010-05-11 15:18:43 +02:00
if [ "$ARCH" = "i486" ]; then
SLKCFLAGS="-O2 -march=i486 -mtune=i686 -DLINUX_OOM_SCORE_ADJ=0"
LIBDIRSUFFIX=""
2010-05-11 15:18:43 +02:00
elif [ "$ARCH" = "i686" ]; then
SLKCFLAGS="-O2 -march=i686 -mtune=i686 -DLINUX_OOM_SCORE_ADJ=0"
LIBDIRSUFFIX=""
2010-05-11 15:18:43 +02:00
elif [ "$ARCH" = "x86_64" ]; then
SLKCFLAGS="-O2 -fPIC -DLINUX_OOM_SCORE_ADJ=0"
LIBDIRSUFFIX="64"
else
SLKCFLAGS="-O2 -DLINUX_OOM_SCORE_ADJ=0"
LIBDIRSUFFIX=""
2010-05-11 15:18:43 +02:00
fi
set -e
2010-05-11 15:18:43 +02:00
rm -rf $TMP/$PRGNAM-$VERSION $PKG
mkdir -p $TMP $PKG $OUTPUT
cd $TMP
tar xvf $CWD/$PRGNAM-$VERSION.tar.bz2
cd $PRGNAM-$VERSION
chown -R root:root .
chmod -R a-s,u+w,go+r-w .
2010-05-11 15:18:43 +02:00
CFLAGS="$SLKCFLAGS" \
./configure \
--prefix=/usr \
--libdir=/usr/lib${LIBDIRSUFFIX} \
--sysconfdir=/etc \
--mandir=/usr/man \
--docdir=/usr/doc/$PRGNAM-$VERSION \
--with-openssl \
--with-tcl \
--with-perl \
--with-python \
--with-ldap \
--with-libxml \
--with-libxslt \
--enable-thread-safety \
--with-system-tzdata=/usr/share/zoneinfo \
--$NLS-nls \
--build=$ARCH-slackware-linux
make
make install-strip DESTDIR=$PKG
make install-docs DESTDIR=$PKG
2010-05-11 15:18:43 +02:00
# Some interesting additional modules:
# http://www.postgresql.org/docs/9.2/static/contrib.html
#
# adminpack - helper extension for pgAdmin
# pgcrypto - extension for some business applications
# hstore, ltree, xml2 - useful extensions for developers
# pg_archivecleanup, pg_standby - high availability helpers
# pg_upgrade, pg_upgrade_support - online upgrade between postgresql versions
PG_EXTENSIONS=${PG_EXTENSIONS:-"adminpack pgcrypto hstore ltree xml2 pg_archivecleanup pg_standby pg_upgrade pg_upgrade_support"}
2010-05-11 15:18:43 +02:00
if [ "x$PG_EXTENSIONS" = "xALL" ];then
cd $TMP/$PRGNAM-$VERSION/contrib
make all
make install-strip DESTDIR=$PKG
else
for ext in $PG_EXTENSIONS; do
cd $TMP/$PRGNAM-$VERSION/contrib/$ext
make
make install-strip DESTDIR=$PKG
done
fi
2010-05-11 15:18:43 +02:00
cd $TMP/$PRGNAM-$VERSION
find $PKG/usr/man -type f -exec gzip -9 {} \;
for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
2010-05-11 15:18:43 +02:00
cp -a COPYRIGHT HISTORY README doc/KNOWN_BUGS doc/MISSING_FEATURES doc/TODO $PKG/usr/doc/$PRGNAM-$VERSION/
rm -rf $PKG/usr/doc/$PRGNAM-$VERSION/{man.tar.gz,man1,manl,man7,postgres.tar.gz}
cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
cat $CWD/README.SBo > $PKG/usr/doc/$PRGNAM-$VERSION/README.SBo
2010-05-11 15:18:43 +02:00
# base database directory
# assumes you are using /var/lib/pgsql as a homedir for postgres user
mkdir -p $PKG/var/lib/pgsql/data
chown -R postgres:postgres $PKG/var/lib/pgsql
chmod 700 $PKG/var/lib/pgsql
# permissions for DATADIR should be u=rwx (0700)
chmod 700 $PKG/var/lib/pgsql/data
# Install init script
2010-05-11 15:18:43 +02:00
mkdir -p $PKG/etc/rc.d
cat $CWD/rc.postgresql.new > $PKG/etc/rc.d/rc.postgresql.new
chmod 0755 $PKG/etc/rc.d/rc.postgresql.new
2010-05-11 15:18:43 +02:00
# Install logrotate script
2010-05-11 15:18:43 +02:00
mkdir -p $PKG/etc/logrotate.d
cat $CWD/postgresql.logrotate > $PKG/etc/logrotate.d/postgresql.new
mkdir -p $PKG/var/log/setup
sed -e "s%@UID@%$PG_UID%" -e "s%@GID@%$PG_GID%" $CWD/setup.$PRGNAM \
> $PKG/var/log/setup/setup.$PRGNAM
chmod 755 $PKG/var/log/setup/setup.$PRGNAM
mkdir -p $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc
cat $CWD/doinst.sh > $PKG/install/doinst.sh
2010-05-11 15:18:43 +02:00
cd $PKG
/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}